/****************************************************************************
    
    This file is part of The Newtonator soft synth.

    Copyright (C) 2010-2011 Michael Bechard <mbechard@users.sourceforge.net>

    The Newtonator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The Newtonator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Newtonator.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

#ifndef SENSITIVITYCONTAINER_H
#define SENSITIVITYCONTAINER_H

#include <vector>
#include <gtkmm.h>

class SensitivityContainer
{
    public:

    SensitivityContainer(bool initialSensitivity = true);
    virtual ~SensitivityContainer();
    inline void Add(Gtk::Widget* item) { m_widgets.push_back(item); }
    inline void Add(SensitivityContainer* item) { item->m_parent = this; m_containers.push_back(item); }
    void SetSensitivity(bool sensitive);
    bool GetSensitivity();

    protected:

    typedef std::vector<Gtk::Widget*> TypeWidgets;
    typedef std::vector<SensitivityContainer*> TypeContainers;

    void CheckSensitivity();

    bool m_sensitive;
    SensitivityContainer* m_parent;
    TypeWidgets m_widgets;
    TypeContainers m_containers;
};

#endif // SENSITIVITYCONTAINER_H
